from capstone import Cs, CS_ARCH_ARM64, CS_MODE_ARM
from keystone import Ks, KS_ARCH_ARM64, KS_MODE_LITTLE_ENDIAN
from unicorn import Uc, UC_ARCH_ARM64, UC_MODE_ARM, UC_HOOK_CODE, arm64_const

STACK_ADDRESS = 0x10000
STACK_SIZE = 0x4000

CODE_ADDRESS = 0x20000

DATA_ADDRESS = 0x30000
DATA_SIZE = 0x10000

ASM_CODE = b""".global func1
.global func2
.global func3

func1:
    sub sp, sp, #0x50
    stp x22, x21, [sp, #0x20]
    stp x20, x19, [sp, #0x30]
    stp x29, x30, [sp, #0x40]
    add x29, sp, #0x40
    mov x19, x2
    mov x20, x1
    mov x21, x0
    nop
    nop
    mov x2, #0x10
    str wzr, [sp, #0x10]
    mov x8, #-1
    str x8, [sp, #8]
    strb wzr, [sp]
    mov x0, x21
    mov x1, x20
    mov x3, x19
    mov w4, #0
    mov w5, #0
    mov w6, #0
    mov w7, #1
    bl func2
    ldp x29, x30, [sp, #0x40]
    ldp x20, x19, [sp, #0x30]
    ldp x22, x21, [sp, #0x20]
    add sp, sp, #0x50
    ret 

func2:
    stp x28, x27, [sp, #-0x60]!
    stp x26, x25, [sp, #0x10]
    stp x24, x23, [sp, #0x20]
    stp x22, x21, [sp, #0x30]
    stp x20, x19, [sp, #0x40]
    stp x29, x30, [sp, #0x50]
    add x29, sp, #0x50
    sub sp, sp, #0x440
    mov x28, x7
    mov x22, x6
    mov x26, x5
    mov x27, x4
    mov x25, x3
    mov x20, x2
    mov x23, x1
    mov x24, x0
    ldr x21, [x29, #0x18]
    adrp x8, 0x10000
    ldr x8, [x8, #0x190]
    ldr x8, [x8]
    stur x8, [x29, #-0x60]
    cbnz x0, #0xe4
    mov w0, #1
    bl #0xfffffffffffcd510
    adrp x8, #0x5157c000
    add x8, x8, #0xbf0
    ldr x8, [x8]
    cmp x0, #0
    csel x24, x8, x0, eq
    mov x19, x24
    cmn x21, #1
    b.eq #0x118
    cbnz x21, #0x114
    mov w0, #1
    bl #0xfffffffffffcd510
    adrp x8, #0x5157c000
    add x8, x8, #0xbf0
    ldr x8, [x8]
    cmp x0, #0
    csel x19, x8, x0, eq
    b #0x118
    mov x19, x21
    ldrb w8, [x29, #0x10]
    str w8, [sp, #0x14]
    cbz x20, #0x168
    str x28, [sp, #8]
    mov w28, #0
    strb wzr, [sp, #0x29]
    cmp w25, #0x100
    b.eq #0x2e8
    adrp x21, #0x10000
    ldr w8, [x21, #0x720]
    cmn w8, #1
    b.ne #0x150
    bl #0xffffffffffffead8
    ldr w8, [x21, #0x720]
    cmp w25, #0x600
    b.eq #0x1dc
    cmp w8, w25
    b.ne #0x1dc
    mov w28, #1
    b #0x2e8
    adrp x8, #0x5157c000
    add x8, x8, #0xbf0
    ldr x21, [x8]
    cmp x21, x24
    b.eq #0x1a0
    cbz x24, #0x194
    adrp x8, #0xe7000
    add x8, x8, #0xc60
    ldr x8, [x8]
    cmp x8, x24
    b.ne #0x124
    bl #0xfffffffffff7c744
    cmp x21, x0
    b.ne #0x124
    ldr w8, [sp, #0x14]
    cbz w8, #0x1c8
    adrp x8, #0x5157c000
    add x8, x8, #0xe78
    ldr x8, [x8]
    cmp x19, x8
    b.eq #0x1c8
    mov x0, x19
    mov x1, x23
    bl #0xfffffffffff7c67c
    adrp x0, #0x51756000
    add x0, x0, #0x650
    bl #0xfffffffffff48194
    mov x27, x0
    b #0xabc
    ubfx w8, w25, #8, #8
    cmp w8, #0xc
    b.hi #0x258
    mov w28, #0
    adrp x9, #0x10000
    add x9, x9, #0x22c
    adr x10, #0x10
    ldrb w11, [x9, x8]
    add x10, x10, x11, lsl #2
    br x10
    mov w28, #0
    cmp w25, #0x22
    b.hi #0x22c
    mov w8, w25
    mov w9, #1
    lsl x8, x9, x8
    mov x9, #0x32
    movk x9, #6, lsl #32
    tst x8, x9
    b.ne #0x2e8
    cmp w25, #0x98
    b.ne #0x2b0
    b #0x2e8
    mov w8, #0x100
    movk w8, #0x800, lsl #16
    cmp w25, w8
    b.eq #0x2b0
    b #0x2e4
    cmp w25, #0x206
    b.ne #0x2b0
    b #0x2e4
    and w8, w25, #0xff00
    cmp w8, #0xc00
    b.ls #0x2b0
    b #0x2e4
    cmp w25, #0x600
    b.eq #0x2b0
    b #0x2e4
    sub w8, w25, #0xa01
    cmp w8, #0xf
    b.hi #0x2b0
    mov w9, #1
    lsl w8, w9, w8
    mov w9, #0x8011
    b #0x2a8
    sub w8, w25, #0xbf3
    cmp w8, #0xc
    b.hi #0x2b0
    mov w9, #1
    lsl w8, w9, w8
    mov w9, #0x1003
    tst w8, w9
    b.ne #0x2e4
    mov x8, x20
    mov x9, x23
    cmp x8, #0x1f
    b.ls #0x3b4
    ldp x10, x11, [x9]
    orr x10, x11, x10
    ldp x11, x12, [x9, #0x10]
    orr x10, x10, x11
    orr x10, x10, x12
    sub x8, x8, #0x20
    add x9, x9, #0x20
    and x10, x10, #0x8080808080808080
    cbz x10, #0x2b8
    mov w28, #0
    cmp w25, #0x100
    cset w8, eq
    cmp w27, #0
    cset w9, ne
    and w9, w9, w8
    tbnz w9, #0, #0x3c0
    orr w8, w8, w28
    tbz w8, #0, #0x3c0
    cmp w25, #0x100
    b.ne #0x52c
    cbz w26, #0x510
    lsr x26, x20, #1
    cbz x26, #0x338
    mov x8, #0
    ldrh w9, [x23, x8, lsl #1]
    cmp w9, #0x7f
    b.hi #0x510
    add x8, x8, #1
    cmp x26, x8
    b.ne #0x320
    cmp x20, #0x200
    cset w13, lo
    cinc x27, x26, lo
    add x21, x27, #1
    cmp x21, #0x3f0
    str x13, [sp]
    b.lo #0x604
    mov x0, x24
    mov x1, x21
    mov x2, #0
    bl #0xfffffffffff7c9a0
    mov x25, x0
    adrp x8, #0x59c46000
    add x8, x8, #0x3d0
    ldrb w8, [x8]
    cbz w8, #0x388
    adrp x1, #0x2b0000
    add x1, x1, #0xc4a
    mov x0, x25
    bl #0xfffffffffffe0fb0
    ldr x13, [sp]
    cbnz x25, #0x60c
    mov w25, #0x100
    mov x20, x21
    b #0x52c
    mov w28, #0
    ldp x10, x11, [x9], #0x10
    orr x10, x11, x10
    sub x8, x8, #0x10
    and x10, x10, #0x8080808080808080
    cbnz x10, #0x2e8
    cmp x8, #0xf
    b.hi #0x39c
    add sp, sp, #0x440
    ldp x29, x30, [sp, #0x50]
    ldp x20, x19, [sp, #0x40]
    ldp x22, x21, [sp, #0x30]
    ldp x24, x23, [sp, #0x20]
    ldp x26, x25, [sp, #0x10]
    ldp x28, x27, [sp], #0x60
    ret

func3:
    nop
    ret 
"""


def trace_inst(uc: Uc, address: int, size: int, user_data: dict):
    for inst in user_data["cs"].disasm_lite(uc.mem_read(address, size), 0):
        print(f"{hex(address)}: {inst[-2]} {inst[-1]}")


def hook_code(uc: Uc, address: int, size: int, user_data: dict):
    # Nested call emu_start
    uc.emu_start(user_data["func_addr"], 0)


def test():
    uc = Uc(UC_ARCH_ARM64, UC_MODE_ARM)
    ks = Ks(KS_ARCH_ARM64, KS_MODE_LITTLE_ENDIAN)
    cs = Cs(CS_ARCH_ARM64, CS_MODE_ARM)

    # These functions are only used to trigger crashes
    # and do not have complete functionality
    encoding, _ = ks.asm(ASM_CODE)
    encoding_bytes = bytes(encoding)

    func1_addr = CODE_ADDRESS + encoding_bytes.find(b"\xff\x43\x01\xd1")
    func3_addr = CODE_ADDRESS + encoding_bytes.rfind(b"\xd5\x03\x20\x1f"[::-1])

    uc.mem_map(CODE_ADDRESS, 1024 * 4)
    uc.mem_write(CODE_ADDRESS, encoding_bytes)

    uc.mem_map(STACK_ADDRESS, STACK_SIZE)
    uc.reg_write(arm64_const.UC_ARM64_REG_SP, STACK_ADDRESS + STACK_SIZE)

    uc.mem_map(DATA_ADDRESS, DATA_SIZE)

    # Set some global data
    uc.mem_write(DATA_ADDRESS + 0x190, (DATA_ADDRESS + 0x190 + 8).to_bytes(8, byteorder="little"))
    uc.mem_write(DATA_ADDRESS + 0x22c, b"\x00\x0d\x12\x15\x15\x15\x19\x15\x39\x15\x1c\x23\x39\x00")

    uc.hook_add(
        UC_HOOK_CODE,
        trace_inst,
        begin=CODE_ADDRESS,
        end=CODE_ADDRESS + len(encoding_bytes),
        user_data={"cs": cs},
    )

    uc.hook_add(
        UC_HOOK_CODE,
        hook_code,
        begin=func3_addr,
        end=func3_addr,
        user_data={"func_addr": func1_addr}
    )

    uc.reg_write(arm64_const.UC_ARM64_REG_X0, 0x2000)
    uc.reg_write(arm64_const.UC_ARM64_REG_X1, DATA_ADDRESS)
    uc.reg_write(arm64_const.UC_ARM64_REG_X2, 0x8000100)

    # First level call emu_start
    uc.emu_start(func3_addr, func3_addr + 4)


if __name__ == '__main__':
    test()
